"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var uuid_1 = require("uuid");
var db_1 = require("./db");
var NEW_TODO = "NEW TODO";
var resolvers = {
    Query: {
        getUser: function (obj, args, ctx, info) { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, {
                        id: uuid_1.v4(),
                        username: "Dawid",
                    }];
            });
        }); },
        getTodos: function (parent, args, ctx, info) { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, [
                        {
                            id: uuid_1.v4(),
                            title: "Zadanie pierwsze",
                            description: "Opis pierwszego zadania",
                        },
                        {
                            id: uuid_1.v4(),
                            title: "Zadanie drugie",
                            description: "Opis drugiego zadania",
                        },
                        {
                            id: uuid_1.v4(),
                            title: "Zadanie trzecie",
                        },
                    ]];
            });
        }); },
    },
    Mutation: {
        addTodo: function (parent, args, _a, info) {
            var pubsub = _a.pubsub;
            return __awaiter(void 0, void 0, void 0, function () {
                var newTodo;
                return __generator(this, function (_b) {
                    newTodo = {
                        id: uuid_1.v4(),
                        title: args.title,
                        description: args.description
                    };
                    db_1.todos.push(newTodo);
                    pubsub.publish(NEW_TODO, { newTodo: newTodo });
                    return [2 /*return*/, db_1.todos[db_1.todos.length - 1]];
                });
            });
        },
    },
    Subscription: {
        newTodo: {
            subscribe: function (parent, args, _a) {
                var pubsub = _a.pubsub;
                return pubsub.asyncIterator(NEW_TODO);
            },
        },
    },
};
exports.default = resolvers;
